package gui;

import clientP2P.*;
import clientP2P.ClientInterface;
import clientP2P.ClientManagement;
import tools.SearchFile;
import tools.LogLevel;
import tools.Logger;
import localException.ProtocolError;
import localException.InternalError;
import localException.ProtocolError;
import localException.SizeError;
import localException.TransmissionError;
import localException.VersionError;
import localException.SocketClosed;
import remoteException.EmptyFile;
import remoteException.EmptyDirectory;
import remoteException.InternalRemoteError;
import remoteException.NotFound;
import remoteException.ProtocolRemoteError;
import remoteException.VersionRemoteError;
import remoteException.NotATracker;
import remoteException.UnknownHost;
import java.io.IOException;
import java.net.UnknownHostException;
import java.net.SocketException;
import javax.swing.JFrame;
import javax.swing.JPanel;


public class DownloadFileGUI extends JPanel{

	private String fileToDownload;
	private ClientManagement clientManagement;
	private Logger logger;
	private static final long serialVersionUID = 13L;


	public DownloadFileGUI(String fileToDownload, ClientManagement clientManagement, Logger logger){
		this.fileToDownload = fileToDownload;
		this.clientManagement = clientManagement;
		this.logger = logger;
	}

	public void download() {
			try {
					System.out.println("Downloading " + fileToDownload + " ... ");
					clientManagement.download(fileToDownload);
					ErrorFrame erreur = new ErrorFrame("File " + fileToDownload + " sucessfully downloaded");
			} catch (NumberFormatException e) {
					ErrorFrame erreur = new ErrorFrame("File " + fileToDownload + " unsucessfully downloaded, wrong number");
			} catch (InternalError e) {
				ErrorFrame err = new ErrorFrame("Client internal error");
			} catch (UnknownHostException e) {
				ErrorFrame err = new ErrorFrame("Server host is unknown");
			} catch (IOException e) {
				ErrorFrame err = new ErrorFrame("Request cannot be send or response cannot be received");
			} catch (TransmissionError e) {
				ErrorFrame err = new ErrorFrame("Message received is too big");
			} catch (ProtocolError e) {
				ErrorFrame err = new ErrorFrame("Cannot decode server’s response");
			} catch (VersionError e) {
				ErrorFrame err = new ErrorFrame("Server’s response use bad version of the protocol");
			} catch (SizeError e) {
				ErrorFrame err = new ErrorFrame("Cannot handle this packets because of internal representation limitations of numbers on the client");
			} catch (InternalRemoteError e) {
				ErrorFrame err = new ErrorFrame("Server internal error");
			} catch (ProtocolRemoteError e) {
				ErrorFrame err = new ErrorFrame("Server cannot decode client’s request");
			} catch (VersionRemoteError e) {
				ErrorFrame err = new ErrorFrame("Server cannot decode this version of the protocol");
			} catch (NotFound e) {
				ErrorFrame err = new ErrorFrame("Server has not this file in directory");
			} catch (EmptyFile e) {
				ErrorFrame err = new ErrorFrame("File is empty");
			}
	}

}
